﻿using System;
using System.Linq;
using System.Web;

using Telerik.Reporting.Processing;

namespace CustomUIExport
{
    public partial class _Default2 : System.Web.UI.Page
    {

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
                ReportViewer1.Report = new ReportWithFooter();

            ReportViewer1.ShowExportGroup = false;
        }

        void ReportExport(Telerik.Reporting.IReportDocument reportToExport, string format)
        {
            if (format.Equals("XLS"))
            {
                var reportWithoutFooter = new ReportWithoutFooter();
                foreach (var parameter in reportToExport.ReportParameters.Where(p=>p.Visible=true))
                {
                    reportWithoutFooter.ReportParameters[parameter.Name].Value = parameter.Value;
                }
                reportToExport = reportWithoutFooter;
            }
            ReportProcessor reportProcessor = new ReportProcessor();
            RenderingResult result = reportProcessor.RenderReport(format, reportToExport, null);
            string fileName = result.DocumentName +"."+ format.ToLower();

            Response.Clear();
            Response.ContentType = result.MimeType;
            Response.Cache.SetCacheability(HttpCacheability.Private);
            Response.Expires = -1;
            Response.Buffer = true;

            Response.AddHeader("Content-Disposition",
                               string.Format("{0};FileName=\"{1}\"",
                                             "attachment",
                                             fileName));

            Response.BinaryWrite(result.DocumentBytes);
            Response.End();
        }

        protected void btnExport_Click(object sender, EventArgs e)
        {
            ReportExport(ReportViewer1.Report, DropDownList1.SelectedValue);
        }

    }
}
